{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
program TraceWrangler;

{$R *.dres}

{$i 'base\jedi.inc'}

uses
  {$ifndef DELPHI21_UP}
  madExcept,
  madLinkDisAsm,
  madListHardware,
  madListProcesses,
  madListModules,
  {$endif }
  SiAuto,
  SmartInspect,
  Vcl.Forms,
  SysUtils,
  main in 'main.pas' {FormMain},
  base_structures in 'base\base_structures.pas',
  class_rawframe in 'base\class_rawframe.pas',
  class_timezonedetails in 'base\class_timezonedetails.pas',
  definition_ip_addresses in 'base\definition_ip_addresses.pas',
  definition_simple_nameresolution in 'base\definition_simple_nameresolution.pas',
  toolkit in 'base\toolkit.pas',
  class_dupechecker in 'loader\class_dupechecker.pas',
  class_loader_enc in 'loader\class_loader_enc.pas',
  class_loader_naicap in 'loader\class_loader_naicap.pas',
  class_tracefilelist in 'loader\class_tracefilelist.pas',
  class_tracefilesetloader in 'loader\class_tracefilesetloader.pas',
  class_tracewriter in 'loader\class_tracewriter.pas',
  class_writer_pcapng in 'loader\class_writer_pcapng.pas',
  base_messages in 'base\base_messages.pas',
  base_determine_protocols in 'base\base_determine_protocols.pas',
  dialog_selecttask in 'dialogs\dialog_selecttask.pas' {FormSelectTask},
  class_ipv4subnethandler in 'storage\class_ipv4subnethandler.pas',
  form_task_separate in 'tasks\form_task_separate.pas' {FormTaskSeparation},
  class_tasklistmanager in 'tasks\class_tasklistmanager.pas',
  form_preferences in 'form_preferences.pas' {FormPreferences},
  class_formstorage in 'base\class_formstorage.pas',
  class_dnsserverlist in 'storage\class_dnsserverlist.pas',
  class_taskprocessor_baseclass in 'tasks\class_taskprocessor_baseclass.pas',
  class_taskprocessor_separate in 'tasks\class_taskprocessor_separate.pas',
  class_taskprocessor_edit in 'tasks\class_taskprocessor_edit.pas',
  class_simpleframestorage in 'storage\class_simpleframestorage.pas',
  form_task_edit in 'tasks\form_task_edit.pas' {FormTaskEdit},
  class_replacement_manager in 'storage\class_replacement_manager.pas',
  class_assembly_baseclass in 'assembly\class_assembly_baseclass.pas',
  class_parser_802dot1q in 'parser\class_parser_802dot1q.pas',
  class_parser_arp in 'parser\class_parser_arp.pas',
  class_parser_baseclass in 'parser\class_parser_baseclass.pas',
  class_parser_dhcpv4 in 'parser\class_parser_dhcpv4.pas',
  class_parser_dns in 'parser\class_parser_dns.pas',
  class_parser_ethernet in 'parser\class_parser_ethernet.pas',
  class_parser_framerelay in 'parser\class_parser_framerelay.pas',
  class_parser_icmpv4 in 'parser\class_parser_icmpv4.pas',
  class_parser_ipv4 in 'parser\class_parser_ipv4.pas',
  class_parser_mpls in 'parser\class_parser_mpls.pas',
  class_parser_tcp in 'parser\class_parser_tcp.pas',
  class_parser_tokenring in 'parser\class_parser_tokenring.pas',
  class_parser_udp in 'parser\class_parser_udp.pas',
  class_assembly_arp in 'assembly\class_assembly_arp.pas',
  class_assembly_ipv6 in 'assembly\class_assembly_ipv6.pas',
  class_assembly_ethernet in 'assembly\class_assembly_ethernet.pas',
  class_assembly_ipv4 in 'assembly\class_assembly_ipv4.pas',
  class_assembly_udp in 'assembly\class_assembly_udp.pas',
  class_ipv6subnethandler in 'storage\class_ipv6subnethandler.pas',
  class_inteldb_manager in 'storage\class_inteldb_manager.pas',
  class_parsemaster in 'parser\class_parsemaster.pas',
  databasetools in 'base\databasetools.pas',
  class_parser_ayiya in 'parser\class_parser_ayiya.pas',
  class_parser_gre in 'parser\class_parser_gre.pas',
  definition_anonymization_struct in 'base\definition_anonymization_struct.pas',
  class_taskprocessor_sanitize in 'tasks\class_taskprocessor_sanitize.pas',
  class_assembly_802dot1q in 'assembly\class_assembly_802dot1q.pas',
  class_assembly_tcp in 'assembly\class_assembly_tcp.pas',
  dialog_anon_replacementdetails in 'dialogs\dialog_anon_replacementdetails.pas' {FormReplacementDetails},
  class_formstorage_anontask in 'tasks\class_formstorage_anontask.pas',
  class_assembly_ayiya in 'assembly\class_assembly_ayiya.pas',
  class_assembly_icmpv4 in 'assembly\class_assembly_icmpv4.pas',
  dialog_anon_editvlanid in 'dialogs\dialog_anon_editvlanid.pas' {FormEditVLANID},
  form_updatenotification in 'form_updatenotification.pas' {FormUpdateNotification},
  form_about in 'form_about.pas' {FormAbout},
  class_parser_ipv6_fragmentationheader in 'parser\class_parser_ipv6_fragmentationheader.pas',
  class_parser_ipv6 in 'parser\class_parser_ipv6.pas',
  class_assembly_ipv6_fragmentationheader in 'assembly\class_assembly_ipv6_fragmentationheader.pas',
  class_assembly_dhcpv4 in 'assembly\class_assembly_dhcpv4.pas',
  class_parser_linux_sll in 'parser\class_parser_linux_sll.pas',
  class_assembly_linux_sll in 'assembly\class_assembly_linux_sll.pas',
  form_task_anonymize in 'tasks\form_task_anonymize.pas' {FormTaskAnonymize},
  class_parser_icmpv6 in 'parser\class_parser_icmpv6.pas',
  common_parse_helpers in 'parser\common_parse_helpers.pas',
  class_assembly_gre in 'assembly\class_assembly_gre.pas',
  class_assembly_mpls in 'assembly\class_assembly_mpls.pas',
  class_assembly_icmpv6 in 'assembly\class_assembly_icmpv6.pas',
  class_parser_juniper in 'parser\class_parser_juniper.pas',
  class_frameprocessor_baseclass in 'frameprocessors\class_frameprocessor_baseclass.pas',
  class_frameprocessor_juniper in 'frameprocessors\class_frameprocessor_juniper.pas',
  class_parser_gtpv1 in 'parser\class_parser_gtpv1.pas',
  class_frameprocessor_gtpu in 'frameprocessors\class_frameprocessor_gtpu.pas',
  class_frameprocessor_gre in 'frameprocessors\class_frameprocessor_gre.pas',
  class_frameprocessor_replaceSLL in 'frameprocessors\class_frameprocessor_replaceSLL.pas',
  class_diagmessagehandler in 'storage\class_diagmessagehandler.pas',
  class_conversationstorage in 'storage\class_conversationstorage.pas',
  form_task_merge in 'tasks\form_task_merge.pas' {FormTaskMerge},
  class_dirparser in 'base\class_dirparser.pas',
  class_interfacemapper in 'storage\class_interfacemapper.pas',
  commander_tools in 'base\commander_tools.pas',
  dialog_edit_interface in 'dialogs\dialog_edit_interface.pas' {FormEditInterface},
  class_taskprocessor_merge in 'tasks\class_taskprocessor_merge.pas',
  class_formstorage_mergetask in 'tasks\class_formstorage_mergetask.pas',
  class_frameprocessor_filter in 'frameprocessors\class_frameprocessor_filter.pas',
  definition_filter_structures in 'base\definition_filter_structures.pas',
  dialog_editfilter in 'dialogs\dialog_editfilter.pas' {FormEditFilter},
  definition_tcp_structures in 'base\definition_tcp_structures.pas',
  definition_conversation_types in 'base\definition_conversation_types.pas',
  base_checksums in 'base\base_checksums.pas',
  dialog_anon_selectaddresses in 'dialogs\dialog_anon_selectaddresses.pas' {FormSelectAddresses},
  dialog_conversation_summary in 'dialogs\dialog_conversation_summary.pas' {FormConversationSummary},
  class_processchain in 'tasks\class_processchain.pas',
  class_frameprocessor_stub in 'frameprocessors\class_frameprocessor_stub.pas',
  inteldb_tools in 'storage\inteldb_tools.pas',
  dialog_configure_conversation_summary in 'dialogs\dialog_configure_conversation_summary.pas' {FormConfigureConversationDisplay},
  class_taskprocessor_extract in 'tasks\class_taskprocessor_extract.pas',
  definition_interface_mapping_types in 'base\definition_interface_mapping_types.pas',
  class_parser_netflow in 'parser\class_parser_netflow.pas',
  class_assembly_netflow in 'assembly\class_assembly_netflow.pas',
  class_parser_hsrp in 'parser\class_parser_hsrp.pas',
  class_assembly_hsrp in 'assembly\class_assembly_hsrp.pas',
  class_parser_vrrp in 'parser\class_parser_vrrp.pas',
  class_parser_geneve in 'parser\class_parser_geneve.pas',
  dialog_anon_selectconversations in 'dialogs\dialog_anon_selectconversations.pas' {FormSelectAnonConversations},
  class_parser_vxlan in 'parser\class_parser_vxlan.pas',
  class_assembly_vxlan in 'assembly\class_assembly_vxlan.pas',
  class_parser_802dot11_radiotap in 'parser\class_parser_802dot11_radiotap.pas',
  class_parser_802dot11header in 'parser\class_parser_802dot11header.pas',
  class_parser_llc in 'parser\class_parser_llc.pas',
  form_task_extract in 'tasks\form_task_extract.pas' {FormTaskExtract},
  datamodule_main in 'datamodule_main.pas' {DataModuleMain: TDataModule},
  class_beaconfile in 'storage\class_beaconfile.pas',
  dialog_conversation_multifilesettings in 'dialogs\dialog_conversation_multifilesettings.pas' {FormMultiFileExtractSettings},
  class_frameprocessor_multiwriter in 'frameprocessors\class_frameprocessor_multiwriter.pas',
  class_formstorage_extracttask in 'tasks\class_formstorage_extracttask.pas',
  class_parse_snortalertlog in 'base\class_parse_snortalertlog.pas',
  dialog_editmetadata in 'dialogs\dialog_editmetadata.pas' {FormEditMetaData},
  dialog_import_filter_from_file in 'dialogs\dialog_import_filter_from_file.pas' {FormImportFilterFromFile},
  class_frameprocessor_mpls in 'frameprocessors\class_frameprocessor_mpls.pas',
  dialog_fqdn_editor in 'dialogs\dialog_fqdn_editor.pas' {FormFQDNEditor},
  dialog_rename_files in 'dialogs\dialog_rename_files.pas' {FormRenameFiles},
  class_assembly_gtpv1 in 'assembly\class_assembly_gtpv1.pas',
  class_frameprocessor_metaupdate in 'frameprocessors\class_frameprocessor_metaupdate.pas',
  class_parse_csvfilterfile in 'base\class_parse_csvfilterfile.pas',
  proxy_tools in 'base\proxy_tools.pas',
  dialog_debuginfo in 'dialogs\dialog_debuginfo.pas' {FormDebugDetails},
  class_parser_erspan in 'parser\class_parser_erspan.pas',
  vstedit_payloadreplacement in 'base\vstedit_payloadreplacement.pas',
  class_interfacelist in 'loader\class_interfacelist.pas',
  class_interfacestatistics in 'loader\class_interfacestatistics.pas',
  class_loader_pcap in 'loader\class_loader_pcap.pas',
  class_loader_pcapng in 'loader\class_loader_pcapng.pas',
  class_traceloader in 'loader\class_traceloader.pas',
  pcapng_structures in 'loader\pcapng_structures.pas',
  tracefile_utils in 'loader\tracefile_utils.pas',
  class_parser_http in 'parser\class_parser_http.pas',
  definition_http_structures in 'base\definition_http_structures.pas',
  class_parser_rtps in 'parser\class_parser_rtps.pas',
  class_assembly_rtps in 'assembly\class_assembly_rtps.pas',
  class_ipfragment_manager in 'storage\class_ipfragment_manager.pas',
  common_assembly_helpers in 'assembly\common_assembly_helpers.pas',
  dialog_goto in 'dialogs\dialog_goto.pas' {FormGoToDialog},
  definition_5tuple in 'base\definition_5tuple.pas',
  dialog_windowlabel in 'dialogs\dialog_windowlabel.pas' {FormWindowLabel},
  class_fqdnmanager in 'storage\class_fqdnmanager.pas',
  class_frameprocessor_metaenhancer in 'frameprocessors\class_frameprocessor_metaenhancer.pas',
  class_frameprocessor_reassembler in 'frameprocessors\class_frameprocessor_reassembler.pas',
  class_parser_capwap in 'parser\class_parser_capwap.pas',
  class_frameprocessor_capwap in 'frameprocessors\class_frameprocessor_capwap.pas',
  class_assembly_802dot11_radiotap in 'assembly\class_assembly_802dot11_radiotap.pas',
  definition_symptoms in 'base\definition_symptoms.pas',
  class_frameprocessor_fixethertypes in 'frameprocessors\class_frameprocessor_fixethertypes.pas',
  class_assembly_llc in 'assembly\class_assembly_llc.pas',
  class_assembly_802dot11header in 'assembly\class_assembly_802dot11header.pas',
  class_parser_802dot11management in 'parser\class_parser_802dot11management.pas',
  class_assembly_802dot11management in 'assembly\class_assembly_802dot11management.pas',
  class_parser_ntp in 'parser\class_parser_ntp.pas',
  Vcl.Themes,
  Vcl.Styles,
  class_parser_tzsp in 'parser\class_parser_tzsp.pas',
  class_frameprocessor_vlan in 'frameprocessors\class_frameprocessor_vlan.pas';

{$R *.res}

begin
{$ifdef debug}
     Si.Enabled := true;

     if FindCmdLineSwitch ('smartdebug') then
        if (ParamStr (2) <> '') and (ExtractFileExt (Paramstr(2)) = '.sil') then
           Si.Connections := 'file(filename=' + ParamStr(2) + ')';

{$else}
     if FindCmdLineSwitch ('smartdebug') then
        begin
             if (ParamStr (2) <> '') and (ExtractFileExt (Paramstr(2)) = '.sil') then
                Si.Connections := 'file(filename=' + ParamStr(2) + ')';

             Si.Enabled := true;
        end;
{$endif}

     Si.Level := lvDebug;
     Si.DefaultLevel := lvDebug;               // for logging without specifying the level, e.g. enterMethod

     Application.Initialize;
     Application.MainFormOnTaskbar := True;
     Application.CreateForm(TFormMain, FormMain);
  Application.CreateForm(TFormSelectTask, FormSelectTask);
  Application.CreateForm(TFormTaskSeparation, FormTaskSeparation);
  Application.CreateForm(TFormPreferences, FormPreferences);
  Application.CreateForm(TFormTaskEdit, FormTaskEdit);
  Application.CreateForm(TFormReplacementDetails, FormReplacementDetails);
  Application.CreateForm(TFormEditVLANID, FormEditVLANID);
  Application.CreateForm(TFormUpdateNotification, FormUpdateNotification);
  Application.CreateForm(TFormAbout, FormAbout);
  Application.CreateForm(TFormTaskAnonymize, FormTaskAnonymize);
  Application.CreateForm(TFormTaskMerge, FormTaskMerge);
  Application.CreateForm(TFormEditInterface, FormEditInterface);
  Application.CreateForm(TFormEditFilter, FormEditFilter);
  Application.CreateForm(TFormSelectAddresses, FormSelectAddresses);
  Application.CreateForm(TFormConversationSummary, FormConversationSummary);
  Application.CreateForm(TFormConfigureConversationDisplay, FormConfigureConversationDisplay);
  Application.CreateForm(TFormSelectAnonConversations, FormSelectAnonConversations);
  Application.CreateForm(TFormTaskExtract, FormTaskExtract);
  Application.CreateForm(TDataModuleMain, DataModuleMain);
  Application.CreateForm(TFormMultiFileExtractSettings, FormMultiFileExtractSettings);
  Application.CreateForm(TFormEditMetaData, FormEditMetaData);
  Application.CreateForm(TFormImportFilterFromFile, FormImportFilterFromFile);
  Application.CreateForm(TFormFQDNEditor, FormFQDNEditor);
  Application.CreateForm(TFormRenameFiles, FormRenameFiles);
  Application.CreateForm(TFormDebugDetails, FormDebugDetails);
  Application.CreateForm(TFormGoToDialog, FormGoToDialog);
  Application.CreateForm(TFormWindowLabel, FormWindowLabel);
  Application.Run;
end.
