      NEXT_HEADER_IPV6_HOP_BY_HOP     = $0000;
      NEXT_HEADER_ICMP                = $0001;
      NEXT_HEADER_IPv4_ENCAPSULATION  = $0004;
      NEXT_HEADER_TCP                 = $0006;
      NEXT_HEADER_EGP                 = $0008;
      NEXT_HEADER_IGP                 = $0009;
      NEXT_HEADER_UDP                 = $0011;
      NEXT_HEADER_IPV6                = $0029;
      NEXT_HEADER_IPV6_ROUTE          = $002B;
      NEXT_HEADER_IPV6_FRAGMENTATION  = $002C;
      NEXT_HEADER_GRE                 = $002F;
      NEXT_HEADER_ESP                 = $0032;
      NEXT_HEADER_AH                  = $0033;
      NEXT_HEADER_IPV6_ICMP           = $003a;
      NEXT_HEADER_NONE                = $003b;  // No further header expected
      NEXT_HEADER_IPV6_DESTINATION    = $003c;
      NEXT_HEADER_ETHERNET            = $0061;  // Adapted from EtherOverIP Type
      NEXT_HEADER_TOKEN_RING          = $0062;  // There is no Token Ring type I could find, so I made this one up because it was free
      NEXT_HEADER_LINUX_COOKED        = $0071;  // same
      NEXT_HEADER_FC                  = $0085;
      NEXT_HEADER_UDPLITE             = $0088;
      NEXT_HEADER_JUNIPER             = $00B2;  // Made up for Juniper Firewall Meta header
      NEXT_HEADER_IPv4                = $0800;
      NEXT_HEADER_ARP                 = $0806;
      NEXT_HEADER_WOL                 = $0842;
      NEXT_HEADER_DECNET_PHASE_IV     = $6003;
      NEXT_HEADER_TRANS_ETHER_BRIDGE  = $6558;
      NEXT_HEADER_RARP                = $8035;
      NEXT_HEADER_APPLETALK           = $809b;
      NEXT_HEADER_APPLETALK_ARP       = $80f3;
      NEXT_HEADER_NOVELL_IPX_OLD      = $8137;
      NEXT_HEADER_8021_Q              = $8100;  // 802.1q
      NEXT_HEADER_NOVEL               = $8137;
      NEXT_HEADER_TYPE_IPV6           = $86dd;
      NEXT_HEADER_TYPE_MAC_CONTROL    = $8808;
      NEXT_HEADER_TYPE_SLOW           = $8809;
      NEXT_HEADER_MPLS_UNICAST        = $8847;
      NEXT_HEADER_MPLS_MULTICAST      = $8848;
      NEXT_HEADER_PPOE_DISCOVERY      = $8863;
      NEXT_HEADER_PPOE_SESSION        = $8864;
      NEXT_HEADER_MICROSOFT_NLB_HB    = $886f;
      NEXT_HEADER_JUMBO_FRAMES        = $8870;
      NEXT_HEADER_HOMEPLUG            = $887b;
      NEXT_HEADER_EAP_OVER_LAN        = $888e;  // 802.1x
      NEXT_HEADER_802_QINQ_Outer      = $88a8;
      NEXT_HEADER_ERSPAN              = $88be;
      NEXT_HEADER_LLDP                = $88cc;
      NEXT_HEADER_FCOE                = $8906;
      NEXT_HEADER_FCOE_INIT           = $8914;
      NEXT_HEADER_802_QINQ_Outer_OLD1 = $9100;
      NEXT_HEADER_802_QINQ_Outer_OLD2 = $9200;
      NEXT_HEADER_802_QINQ_Outer_OLD3 = $9300;
      NEXT_HEADER_SNAP                = $aaaa;

      // TCP & UDP and other Protocols

      NEXT_HEADER_DNS                 = $10035;  //   53
      NEXT_HEADER_DHCPv4              = $10043;  //   67
      NEXT_HEADER_HTTP                = $10050;  //   80
      NEXT_HEADER_80211RADIO          = $1007f;  //  127
      NEXT_HEADER_HSRP                = $107C1;  // 1985
      NEXT_HEADER_GTPv1               = $10868;  // 2152
      NEXT_HEADER_VXLAN               = $112B5;  // 4789
      NEXT_HEADER_AYIYA               = $113d0;  // 5072
      NEXT_HEADER_CAPWAP              = $1147f;  // 5247
      NEXT_HEADER_GENEVE              = $117c1;  // 6081
      NEXT_HEADER_NETFLOW             = $1270C;  // 9996
      NEXT_HEADER_TZSP                = $19090;  // 37008
      NEXT_HEADER_RTPS                = $20001;  // arbitrary
      NEXT_HEADER_NTP                 = $20002;  // aribtrary

      // IP protocols

      NEXT_HEADER_VRRP                = $20070;

      NEXT_HEADER_LLC                 = $ffff8;  // Link Layer Control
      NEXT_HEADER_802dot11Hdr         = $ffff9;  // This is what follows the radiotap header and is the start of the real content of the packet
      NEXT_HEADER_802dot11Mgmt        = $ffffa;  // This is what follows the radiotap header and is the start of the real content of the packet
      NEXT_HEADER_802dot11Ctrl        = $ffffb;  // This is what follows the 802.11 header when the content is a management frame
      NEXT_HEADER_DYNAMIC             = $ffffc;  // Means that the next header must be determined by other means; usually this happens for protocols higher than TCP/UDP -> port numbers need to be examined for this
      NEXT_HEADER_PAYLOAD             = $ffffd;  // used if the remaining bytes are some sort of unknown payload
      NEXT_HEADER_UNKNOWN             = $fffff;  // Showstopper... as soon as this is returned the parser cannot process the next header

