{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

unit class_parser_framerelay;

interface

uses base_structures,
     common_parse_helpers,
     class_parser_baseclass;


type

     tFrameRelayParser  = class (tFrameParser)

                                private


                                public
                                      function checkIsPlausible : boolean; override;
                                      function parse : tParseResult; override;
                          end;





implementation

uses Toolkit;

(* ------------------------------------------- *)
{ tFrameRelayParser }
(* ------------------------------------------- *)

function tFrameRelayParser.checkIsPlausible : boolean;

begin
     result := true;
end;

(* ------------------------------------------- *)

function tFrameRelayParser.parse: tParseResult;

var // pData  : pStruct_Ethernet;
    status : tParseResult;

begin
     status := prSuccess;

     priv_osilayer := 2;     // Set Layer this parser is for
{
     if priv_framelength < sizeOf (tStruct_Ethernet) then
        status := prFailUndersize
     else
         try

            pData := pStruct_Ethernet (priv_framedata);

            priv_ethsrc.RangeBytes := pData^.src;
            priv_ethdst.RangeBytes := pData^.dst;

            help := pData^.ethtypelength;

            priv_ethertypelength := swap16 (help);

            // Set the next header type - usually the same as the ether type

            if priv_ethertypelength > $0600 then
               begin
                    priv_nextAnchor.HeaderType := priv_ethertypelength;
                    priv_nextAnchor.Offset := sizeOf (tStruct_Ethernet);
               end
            else
                parse802dot3frame (status);

         except
               status := prFailInvalidValues;
         end;
}
     result := status;
end;

(* ------------------------------------------- *)

end.
