{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}

 unit class_flowhandler_tcp;

interface

uses contnrs,
     definition_ip_addresses,
     definition_tcp_structures,
     class_rawframe,
     class_flowhandler_baseclass,
     class_parser_tcp;

type tTCPFlowHandler = class (tFlowHandler)

                             constructor create (Frame : tRawFrame); overload;
                             procedure free;

                             private
                                    prot_framelist_revised : tObjectlist;     // List of frames reordered and de-duplicated (retransmissions)

                                    priv_isIPv4            : boolean;

                                    priv_ipv4socketpair    : tIPv4SocketPair;
                                    priv_ipv6socketpair    : tIPv6SocketPair;

                                    priv_Flags             : tTCPFlagSet;
                                    priv_HandshakeFound    : boolean;
                                    priv_GracefulShutdown  : boolean;
                                    priv_Reset             : boolean;

                                    priv_initialsequence   : longword;
                                    priv_lastsequence      : longword;

                                    priv_retransmissions   : integer;
                                    priv_out_of_orders     : integer;
                                    priv_gapcount          : integer;

                                    procedure initialize;

                             protected

                                      procedure processFrame; override;

                             public

                       end;

implementation

(* ------------------------------------------- *)
{ tFlowHandler }
(* ------------------------------------------- *)

constructor tTCPFlowHandler.create (Frame : tRawFrame);

begin
     inherited create (Frame);

     priv_isIPv4 := true;
//   priv_ipv4socketpair := SocketPair;

     prot_framelist_revised := TObjectList.Create (false);
end;

(* ------------------------------------------- *)

procedure tTCPFlowHandler.free;

begin
     prot_framelist_revised.free;

     inherited;
end;

(* ------------------------------------------- *)

procedure tTCPFlowHandler.initialize;

begin
     priv_Flags := [];
     priv_HandshakeFound := false;
     priv_GracefulShutdown := false;
     priv_Reset := false;

     priv_initialsequence := 0;
     priv_lastsequence := 0;

     priv_retransmissions := 0;
     priv_out_of_orders := 0;
     priv_gapcount := 0;
end;

(* ------------------------------------------- *)

procedure tTCPFlowHandler.processFrame;

begin


end;

(* ------------------------------------------- *)

end.
