{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_assembly_ipv4;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_assembly_baseclass, class_assembly_ipv4, class_parser_ipv4,
  base_structures, definition_ip_addresses;

type // Test methods for class tEthernetAssembler

     TesttIPv4Assembler = class (TTestCase)
                                strict private
                                       FtIPv4Assembler: tIPv4Assembler;

                                public
                                      procedure SetUp; override;
                                      procedure TearDown; override;

                                published
                                         procedure TestAssemble;
                                         procedure TestCopyFromParser;
                          end;

implementation

uses sysutils;

(* ------------------------------------------- *)

procedure TesttIPv4Assembler.SetUp;

begin
     FtIPv4Assembler := tIPv4Assembler.Create (0);
end;

(* ------------------------------------------- *)

procedure TesttIPv4Assembler.TearDown;

begin
     FtIPv4Assembler.Free;
     FtIPv4Assembler := nil;
end;

(* ------------------------------------------- *)

procedure TesttIPv4Assembler.TestAssemble;

var ip  : tIPv4Address;
    opt : tIPv4Option;
    hlp : tIPv4Address;
    i   : integer;

begin
     FtIPv4Assembler.Version := 4;
//   FtIPv4Assembler.IHL := 20;           // this is default and implicitly set
     FtIPv4Assembler.TOS := 0;
     FtIPv4Assembler.Identification := 0;
     FtIPv4Assembler.Flags := [];
     FtIPv4Assembler.Offset := 0;
     FtIPv4Assembler.TTL := 252;
     FtIPv4Assembler.Protocol := 1;

     ip.setValueFromString('100.0.0.1');
     FtIPv4Assembler.Source := ip;

     ip.setValueFromString('14.0.0.2');
     FtIPv4Assembler.Destination := ip;

     opt.setOptionType(7);
     opt.OptionLength := 39;
     opt.OptionPointer := 40;

     setLength (opt.RouteRecords, 9);

     hlp.setValueFromString('14.0.0.2');
     opt.RouteRecords[0] := hlp;

     hlp.setValueFromString('13.0.0.1');
     opt.RouteRecords[1] := hlp;

     hlp.setValueFromString('11.0.0.2');
     opt.RouteRecords[2] := hlp;

     hlp.setValueFromString('10.0.0.2');
     opt.RouteRecords[3] := hlp;

     hlp.setValueFromString('100.0.0.1');
     opt.RouteRecords[4] := hlp;

     hlp.setValueFromString('10.0.0.1');
     opt.RouteRecords[5] := hlp;

     hlp.setValueFromString('11.0.0.1');
     opt.RouteRecords[6] := hlp;

     hlp.setValueFromString('13.0.0.2');
     opt.RouteRecords[7] := hlp;

     hlp.setValueFromString('14.0.0.1');
     opt.RouteRecords[8] := hlp;

     FtIPv4Assembler.AddOptionRecord (opt);

     FtIPv4Assembler.GetAssembly;
end;

(* ------------------------------------------- *)

procedure TesttIPv4Assembler.TestCopyFromParser;

var Parser: tIPv4Parser;

begin
     FtIPv4Assembler.CopyFromParser(Parser);
end;

(* ------------------------------------------- *)

initialization
              // Register any test cases with the test runner
              RegisterTest(TesttIPv4Assembler.Suite);
end.

