{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_frameprocessor_filter;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, definition_filter_structures, base_structures, class_parsemaster,
  class_frameprocessor_baseclass, class_rawframe, class_frameprocessor_filter;

type
  // Test methods for class tFrameProcessorFilter

  TesttFrameProcessorFilter = class(TTestCase)
  strict private
    FtFrameProcessorFilter: tFrameProcessorFilter;
  public
  published
           procedure TestFilter;
  end;

implementation

uses SysUtils,
     class_loader_pcapng,
     class_processchain;

(* ------------------------------------------- *)

procedure TesttFrameProcessorFilter.TestFilter;

var loader    : tPCAPngLoader;
    processor : tFrameProcessor;
    filter    : tFrameFilter;
    filterset : tFilterSet;
    chain     : tProcessChain;
    fileframe : tRawFrame;
    testframe : tRawFrame;
    newframe  : tRawFrame;
    Parser    : tParseMaster;
    i         : Integer;


begin
     // Prepare a filter

     filter.initialize;
     filter.IPv4Filter.AddressFilterType := ftSingle;
     filter.IPv4Filter.SingleAddress.setValueFromString ('1.2.3.4');

//   setlength (filterset, 1);
//   filterset[0] := filter;
     filterset := tFilterset.create;
     filterset.AddFilter (filter);

     chain := tProcessChain.create;

     processor := tFrameProcessorFilter.create ('FilterEngine', filterset);
     chain.AddProcessor (processor);

     // Now Load a test frame and see what happens

//   loader := tPCAPngLoader.create ('D:\Traces\ScanTest\Test Single Save File 1.pcapng');
     loader := tPCAPngLoader.create ('Z:\D-Drive\Traces\Gigatrace2\TWDemo_00001_20140706182002.pcapng');
     loader.openFile;
     loader.readTraceFileheader;
     loader.MaxFramesInMem := 100000;
     loader.readBatchFromDisk;

     for i := 1 to Loader.FramesAvailable do
         begin
              testframe := Loader.getRawFrame (i);

              chain.ProcessFrame (testframe, newframe);
         end;

     loader.closeFile;
     loader.free;

     filterset.Free;

     chain.free;
end;

(* ------------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttFrameProcessorFilter.Suite);
end.

