{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_frameprocessor_juniper;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_parser_juniper, class_frameprocessor_juniper,
  class_rawframe, class_frameprocessor_baseclass, base_structures;

type
  // Test methods for class tFrameProcessorJuniper

  TesttFrameProcessorJuniper = class(TTestCase)

                                     strict private
                                                   FtFrameProcessorJuniper: tFrameProcessorJuniper;
                                     public
                                           procedure SetUp; override;
                                           procedure TearDown; override;

                                     published
                                              procedure TestProcessL2Frame;
                                              procedure TestProcessL4FrameToRawIP;
                                              procedure TestProcessL4FrameToFakeEthernet;
                                     end;

implementation

uses base_testhelpers;

(* ------------------------------------------- *)

procedure TesttFrameProcessorJuniper.SetUp;

begin
     FtFrameProcessorJuniper := tFrameProcessorJuniper.Create ('Test');
end;

(* ------------------------------------------- *)

procedure TesttFrameProcessorJuniper.TearDown;

begin
     FtFrameProcessorJuniper.Free;
     FtFrameProcessorJuniper := nil;
end;

(* ------------------------------------------- *)

procedure TesttFrameProcessorJuniper.TestProcessL2Frame;

var ProcessedFrame : tRawFrame;
    Frame          : tRawFrame;

begin
     Frame := ReadSingleFrameFromDisk ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Juniper-L2Present.pcapng');

     ProcessedFrame := FtFrameProcessorJuniper.getProcessedFrame (Frame);

//   WriteSingleFrameToDisk ('D:\testframe_l2.pcapng', ProcessedFrame);

     CheckEquals ('BA26AA0231BB1FD84CD57652C995F75E', ProcessedFrame.MD5Hash, 'Hash failure for processed frame');

     ProcessedFrame.free;
end;

(* ------------------------------------------- *)

procedure TesttFrameProcessorJuniper.TestProcessL4FrameToRawIP;

var ProcessedFrame : tRawFrame;
    Frame          : tRawFrame;

begin
     Frame := ReadSingleFrameFromDisk ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Juniper-L4.pcapng');

     FtFrameProcessorJuniper.AddPseudoL2Header := plmNone;

     ProcessedFrame := FtFrameProcessorJuniper.getProcessedFrame (Frame);

//   WriteSingleFrameToDisk ('D:\testframe_l4rawip.pcapng', ProcessedFrame);

     CheckEquals ('9D49EA054301291CEE2F809016267151', ProcessedFrame.MD5Hash, 'Hash failure for processed frame');

     ProcessedFrame.free;
end;

(* ------------------------------------------- *)

procedure TesttFrameProcessorJuniper.TestProcessL4FrameToFakeEthernet;

var ProcessedFrame : tRawFrame;
    Frame          : tRawFrame;

begin
     Frame := ReadSingleFrameFromDisk ('D:\Software Development\Jays Utilities\Trace Wrangler\test\traces\Juniper-L4.pcapng');

     FtFrameProcessorJuniper.AddPseudoL2Header := plmWithFrameComment;

     ProcessedFrame := FtFrameProcessorJuniper.getProcessedFrame (Frame);

     WriteSingleFrameToDisk ('D:\testframe_l4fakeeth.pcapng', ProcessedFrame);

     CheckEquals ('13637A3F505134C88EFDE6C80FC35521', ProcessedFrame.MD5Hash, 'Hash failure for processed frame');

     ProcessedFrame.free;
end;

(* ------------------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttFrameProcessorJuniper.Suite);
end.

