{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_parse_snortalertlog;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit
  being tested.

}

interface

uses
  TestFramework, DBXJSON, definition_filter_structures, base_structures,
  definition_tcp_structures, class_parse_snortalertlog, definition_ip_addresses;

type
     // Test methods for class tSnortAlertParser

     TesttSnortAlertParser = class (TTestCase)

                                   strict private
                                          SnortParser: tSnortAlertParser;
                                   public

                                   published
//                                          procedure Testexecute;
                                            procedure TestMetaDataJSONExport;
                                            procedure LoadSignatures;
                                            procedure TestLoadUnified2;
                                            procedure TestLoadTextAlerts;
                             end;

implementation

uses DateUtils,
     System.JSON;

{
procedure TesttSnortAlertParser.Testexecute;

begin
     FtSnortAlertParser.execute;
end;
}
{ TesttSnortAlertParser }

(* ----------------------------------- *)

procedure TesttSnortAlertParser.TestMetaDataJSONExport;

var value1    : tMetaDataEntry;
    value2    : tMetaDataEntry;
    JSONValue : tJSONObject;

begin
     value1.initialize;

     value1.IPVersion := 4;
     value1.IPv4SocketPair.Source.initialize ('192.168.0.1:1025');
     value1.IPv4SocketPair.Destination.initialize ('10.0.0.1:80');
     value1.IPv6SocketPair.initialize;
     value1.IPID := 12345;
     value1.Layer4Protocol := l4TCP;
     value1.TCPSequenceNumber := $12345;
     value1.Timestamp.datetime := encodeDateTime (2015, 03, 09, 03, 04, 30, 0);
     value1.Timestamp.nanoseconds := 123456;
     value1.RuleDetails.Comment := 'TestComment';

     JSONValue := value1.toJSON;
     value2.initialize (JSONValue);

     CheckTrue (value1 = value2, 'Value1 equals Value2');
end;

(* ----------------------------------- *)

procedure TesttSnortAlertParser.LoadSignatures;

begin
     SnortParser.LoadRuleDefinitions ('D:\Development\Jays Utilities\Trace Wrangler\test\snort\downloaded.rules');
end;

(* ----------------------------------- *)

procedure TesttSnortAlertParser.TestLoadUnified2;

begin
//   SnortParser := tSnortAlertParser.create ('D:\Development\Jays Utilities\Trace Wrangler\test\snort\snort.unified2.1511537305');
     SnortParser := tSnortAlertParser.create ('C:\Users\Jasper\Desktop\snort.unified2.1511538417');

     SnortParser.LoadRuleDefinitions ('D:\Development\Jays Utilities\Trace Wrangler\test\snort\downloaded.rules');

     CheckTrue (SnortParser.FileFormat = sfUnified2, 'Format should be Unified2');

     SnortParser.execute;

     CheckTrue (not SnortParser.UnifiedFileReadFailure, 'Read failure parsing Unified2 file');

     SnortParser.Free;
end;

(* ----------------------------------- *)

procedure TesttSnortAlertParser.TestLoadTextAlerts;

begin
     SnortParser := tSnortAlertParser.create ('D:\Development\Jays Utilities\Trace Wrangler\test\snort\alert.ids');

     CheckTrue (SnortParser.FileFormat = sfTextAlerts, 'Format should be Unified2');

     SnortParser.Free;
end;

(* ----------------------------------- *)

initialization
              // Register any test cases with the test runner

              RegisterTest(TesttSnortAlertParser.Suite);
end.

