{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_parser_gtpv1;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit
  being tested.

}

interface

uses
  TestFramework, class_parser_baseclass, class_parser_gtpv1, base_structures, class_parsemaster;

type
  // Test methods for class tGTPv1Parser

  TesttGTPv1Parser = class(TTestCase)
  strict private
                Parsemaster : tParseMaster;

                function PrepareTest (Tracefile : string) : tGTPv1Parser;
  public

  published
           procedure TestparseGTPuPing;
  end;

implementation

uses class_rawframe,
     class_loader_pcapng;

(* ------------------------------------------- *)

function TesttGTPv1Parser.PrepareTest(Tracefile: string) : tGTPv1Parser;

var Loader      : tPCAPNGLoader;
    Frame       : tRawFrame;
    GTPv1Parser : tGTPv1Parser;
    OpenResult  : boolean;
    i           : integer;

begin
     Loader := tPCAPNGLoader.create (Tracefile);
     OpenResult := Loader.openFile;

     Loader.readTraceFileheader;
     Loader.readBatchFromDisk;

     Frame := Loader.getRawFrame(1);

     ParseMaster := tParseMaster.create (Frame, ppmParseAll);

     Loader.Free;
     Loader := nil;

     CheckEquals (true, Openresult, 'PCAPNGLoader.OpenFile Failed');

     // Find the ICMP Parser

     i := 0;

     repeat
           inc (i)
     until (Parsemaster.getParserTypeByIndex (i) = NEXT_HEADER_GTPv1) or (i >= Parsemaster.ParserCount);

     if (Parsemaster.getParserTypeByIndex (i) = NEXT_HEADER_GTPv1) then
        GTPv1Parser := (Parsemaster.getParserByIndex (i) as tGTPv1Parser)
     else
         GTPv1Parser := nil;

     result := GTPv1Parser;
end;

(* ------------------------------------------- *)

procedure TesttGTPv1Parser.TestparseGTPuPing;

var GTPv1Parser : tGTPv1Parser;

begin
     GTPv1Parser := PrepareTest ('d:\Software Development\Jays Utilities\Trace Wrangler\test\traces\GTPv1-PingSample.pcapng');

     if GTPv1Parser <> nil then
        begin
             CheckEquals (12, GTPv1Parser.LayerSize, 'LayerSize');
             CheckEquals (GTP_MSG_TPDU, GTPv1Parser.MessageType, 'MessageType');
             CheckEquals (88, GTPv1Parser.TotalLength, 'Total Length');

             CheckEquals (NEXT_HEADER_IPv4, GTPv1Parser.NextAnchor.HeaderType, 'Next Header');
             CheckEquals ($36, GTPv1Parser.NextAnchor.Offset, 'Next Offset');
        end;
end;

(* ------------------------------------------- *)

initialization
  // Register any test cases with the test runner
  RegisterTest(TesttGTPv1Parser.Suite);
end.

