{ TraceWrangler - Network Capture File Toolkit
  By Jasper Bongertz <jasper@packet-foo.com>
  Copyright 2016 Jasper Bongertz
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
 
unit Testclass_parser_ipv6;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, class_parser_ipv6, base_checksums, base_structures,
  common_parse_helpers, definition_ip_addresses, class_parser_baseclass, class_parsemaster;

type // Test methods for class tIPv6Parser

     TesttIPv6Parser = class (TTestCase)
                             strict private
                                           Parsemaster : tParseMaster;

                                           function PrepareTest (Tracefile : string) : tIPv6Parser;
                              public

                              published
                                       procedure TestparseFragment;
                              end;

implementation

uses class_rawframe,
     class_loader_pcapng;

(* -------------------------------------- *)

function TesttIPv6Parser.PrepareTest(Tracefile: string): tIPv6Parser;

var Loader      : tPCAPNGLoader;
    Frame       : tRawFrame;
    IPParser    : tIPv6Parser;
    OpenResult  : boolean;
    i           : integer;

begin
     Loader := tPCAPNGLoader.create (Tracefile);
     OpenResult := Loader.openFile;

     Loader.readTraceFileheader;
     Loader.readBatchFromDisk;

     Frame := Loader.getRawFrame(1);

     ParseMaster := tParseMaster.create (Frame, ppmParseAll);

     Loader.Free;
     Loader := nil;

     CheckEquals (true, Openresult, 'PCAPNGLoader.OpenFile Failed');

     i := 0;

     // Find the IP Parser

     repeat
           inc (i)
     until (Parsemaster.getParserTypeByIndex (i) = NEXT_HEADER_TYPE_IPV6) or (i >= Parsemaster.ParserCount);

     if (Parsemaster.getParserTypeByIndex (i) = NEXT_HEADER_TYPE_IPV6) then
        IPParser := (Parsemaster.getParserByIndex (i) as tIPv6Parser)
     else
         IPParser := nil;

     result := IPParser;
end;

(* -------------------------------------- *)

procedure TesttIPv6Parser.TestparseFragment;

var IPParser : tIPv6Parser;

begin
     IPParser := PrepareTest ('d:\Software Development\Jays Utilities\Trace Wrangler\test\traces\IPv6-Fragmentationheader.pcapng');

     if IPParser <> nil then
        begin
             CheckEquals ('222::2', IPParser.Source.ValueAsString, 'Source IP');
             CheckEquals ('333::3', IPParser.Destination.ValueAsString, 'Destination IP');
             CheckEquals (16, IPParser.PayloadLength, 'Payload Length');
             CheckEquals (0, IPParser.HopLimit, 'Hop Limit');
             CheckEquals (44, IPParser.NextHeader, 'Next Header');
             CheckEquals (NEXT_HEADER_IPV6_FRAGMENTATION, IPParser.NextAnchor.HeaderType, 'Next Anchor');
        end;
end;

(* -------------------------------------- *)

initialization
              // Register any test cases with the test runner
              RegisterTest (TesttIPv6Parser.Suite);
end.

